<template>
    <div>

        <div>
          <i-form :model="page" inline :label-width="80">
            <form-item label="Название">
              <i-input v-model="page.name" type="text" placeholder="Название">
              </i-input>
            </form-item>
            <form-item label="Порядок">
              <i-input v-model="page.command" type="text" placeholder="Порядок">
              </i-input>
            </form-item>
            <form-item label="СID">
              <InputNumber v-model="page.cid" :min="0">
              </InputNumber>
            </form-item>
            <form-item label="Текущее состояние">
              <i-select v-model="page.status" style="width:200px">
                <Option value="0">Все</Option>
                <Option value="1">Ожидание</Option>
                <Option value="2">Начало</Option>
                <Option value="3">Успешно</Option>
                <Option value="4">Неудача</Option>
              </i-select>
            </form-item>
                <i-button type="primary" icon="ios-search" @click="loadPage">Проверить</i-button> &nbsp;&nbsp;
                <i-button type="success" v-model="showPut" icon="ios-add-circle" @click="windowAddTask">Новое</i-button>
            </i-form>
        </div>
        <div>
            <Table border :columns="columns" :data="tasks">
                <template slot-scope="{ row }" slot="disable">
                    <i-switch size="large" v-model="row.disable" @on-change="switchTaskStatus(row)">
                    </i-switch>
                </template>
                <template slot-scope="{ row }" slot="log_enable">
                    <i-switch size="large" v-model="row.log_enable" @on-change="switchTaskStatus(row)">
                    </i-switch>
                </template>
                <template slot-scope="{ row }" slot="action">
                    <Button type="info" size="small" @click="viewLog(row)">Журнал</Button>
                    <Button type="primary" size="small" @click="rowPutTask(row)">Редактор</Button>
                    <Button type="error" size="small" @click="confirmRemove(row)">Стереть</Button>
                    <Button type="info" size="small" @click="runTask(row)">Управлять</Button>
                </template>
            </Table>
            <div style="margin: 10px;overflow: hidden">
                <div style="float: right;">
                    <Page :total="page.total" :page-size="page.count" @on-change="changePageIndex"
                          @on-page-size-change="changePageSize" show-sizer/>
                </div>
            </div>
        </div>
        <div>
            <Modal v-model="showPut" title="Оперативные задачи" @on-ok="putTask">
                <div>
                    <i-form ref="form" :model="task" :label-width="80">
                        <FormItem label="TID">
                            <i-input v-model="task.tid" disabled></i-input>
                        </FormItem>
                        <FormItem label="Имя задачи">
                            <i-input v-model="task.name"></i-input>
                        </FormItem>
                        <FormItem label="Bash">
                            <i-input type="textarea" v-model="task.command" clearable></i-input>
                        </FormItem>
                        <FormItem label="Прервать">
                            <i-input v-model="task.timeout"></i-input>
                        </FormItem>

                        <FormItem label="Включить ведение журнала">
                            <i-switch v-model="task.log_enable"></i-switch>
                        </FormItem>

                        <FormItem label="Отключить задачу">
                            <i-switch v-model="task.disable"></i-switch>
                        </FormItem>

                        <FormItem label="Список действий">
                            <i-input v-model="task.directory"></i-input>
                        </FormItem>
                    </i-form>
                </div>
            </Modal>
        </div>
    </div>
</template>

<script>
import { getTasks, putTask, deleteTask, runTask } from '../../api/task'
import { getDateTimeStr } from '@/libs/util'

export default {
  name: 'TaskList',
  mounted: function () {
    this.loadPage()
  },

  data () {
    return {
      tasks: [],
      showPut: false,
      page: {
        order: 'tid',
        name: '',
        command: '',
        cid: 0,
        status: 0,
        total: 0,
        index: 1,
        count: 20
      },
      task: {
        tid: 0,
        name: '',
        command: '',
        timeout: 0,
        log_enable: false,
        disable: false,
        directory: ''
      },
      statusBtn: {
        1: {
          props: {
            type: 'info',
            size: 'small',
            icon: 'md-arrow-down'
          },
          text: 'Ожидание'
        },
        2: {
          props: {
            type: 'primary',
            size: 'small',
            loading: true
          },
          text: 'Выполнить'
        },
        3: {
          props: {
            type: 'success',
            size: 'small',
            icon: 'md-checkmark'
          },
          text: 'Успешно'
        },
        4: {
          props: {
            size: 'small',
            type: 'error',
            icon: 'md-close'
          },
          text: 'Неудача'
        }
      },
      search: '',
      columns: [
        {
          title: 'Состояние',
          key: 'status',
          width: '120',
          render: (h, params) => {
            let status = params.row.status
            let p = this.statusBtn[status.toString()]
            return h('Button', {
              props: p.props
            }, p.text)
          }
        },
        {
          title: 'Имя задачи',
          key: 'name',
          tooltip: true,
          width: '200'
        },
        {
          title: 'СID',
          key: 'cid',
          width: '80'
        },
        {
          title: 'Disable',
          key: 'disable',
          slot: 'disable',
          width: '100'
        },
        {
          title: 'Bash',
          key: 'command',
          resizable: true,
          tooltip: true
        },
        {
          title: 'Включить ведение журнала',
          slot: 'log_enable',
          key: 'log_enable',
          width: '100'
        },
        {
          title: 'Время работы',
          key: 'update_at',
          width: '150',
          render: (h, params) => {
            let status = params.row.update_at
            let p = getDateTimeStr(status)
            return h('Span', {}, p)
          }
        },
        {
          title: 'Управление',
          key: 'action',
          align: 'center',
          slot: 'action',
          width: '240'
        }
      ]
    }
  },

  methods: {
    loadPage: function () {
      getTasks(this.page).then(data => {
        this.tasks = data.items
        this.page.total = data.page.total
      })
    },
    putTask: function () {
      putTask(this.task).then(() => {
        this.$Message.success('Success')
        this.loadPage()
      }
      )
    },
    rowPutTask: function (row) {
      this.task = row
      this.showPut = true
    },
    windowAddTask: function () {
      this.task = {
        tid: 0,
        name: '',
        expression: '',
        command: '',
        timeout: 0,
        log_enable: false,
        disable: false,
        directory: ''
      }
      this.showPut = true
    },
    changePageIndex: function (page) {
      this.page.index = page
      this.loadPage()
    },
    changePageSize: function (size) {
      this.page.index = 1
      this.page.count = size
      this.loadPage()
    },
    runTask: function (task) {
      this.$Message.info('Открытая задача')
      runTask(task).then(() => {
        this.$Message.info('Success')
      })
      this.loadPage()
    },
    confirmRemove: function (task) {
      let cur = this
      this.$Modal.confirm({
        title: 'Подтвердить',
        content: '<p>Удалить текущую задачу?</p>',
        onOk: () => {
          cur.remove(task)
        }
      })
    },
    remove: function (task) {
      deleteTask(task.tid).then(() => {
        this.$Message.success('Успешно удалено!')
        this.loadPage()
      })
    },
    switchTaskStatus: function (task) {
      putTask(task).then(() => {
        this.$Message.success('Success~')
        this.loadPage()
      }
      )
    },
    viewLog: function (task) {
      this.$router.push({ name: 'log-list', params: { tid: task.tid } })
    }
  }
}
</script>
